/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the RevokeConsentRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RevokeConsentRequest{}

// RevokeConsentRequest struct for RevokeConsentRequest
type RevokeConsentRequest struct {
	Key *string `json:"key,omitempty"`
	ConsentId *string `json:"consent_id,omitempty"`
	Context *string `json:"context,omitempty"`
}

// NewRevokeConsentRequest instantiates a new RevokeConsentRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRevokeConsentRequest() *RevokeConsentRequest {
	this := RevokeConsentRequest{}
	return &this
}

// NewRevokeConsentRequestWithDefaults instantiates a new RevokeConsentRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRevokeConsentRequestWithDefaults() *RevokeConsentRequest {
	this := RevokeConsentRequest{}
	return &this
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *RevokeConsentRequest) GetKey() string {
	if o == nil || IsNil(o.Key) {
		var ret string
		return ret
	}
	return *o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RevokeConsentRequest) GetKeyOk() (*string, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *RevokeConsentRequest) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given string and assigns it to the Key field.
func (o *RevokeConsentRequest) SetKey(v string) {
	o.Key = &v
}

// GetConsentId returns the ConsentId field value if set, zero value otherwise.
func (o *RevokeConsentRequest) GetConsentId() string {
	if o == nil || IsNil(o.ConsentId) {
		var ret string
		return ret
	}
	return *o.ConsentId
}

// GetConsentIdOk returns a tuple with the ConsentId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RevokeConsentRequest) GetConsentIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConsentId) {
		return nil, false
	}
	return o.ConsentId, true
}

// HasConsentId returns a boolean if a field has been set.
func (o *RevokeConsentRequest) HasConsentId() bool {
	if o != nil && !IsNil(o.ConsentId) {
		return true
	}

	return false
}

// SetConsentId gets a reference to the given string and assigns it to the ConsentId field.
func (o *RevokeConsentRequest) SetConsentId(v string) {
	o.ConsentId = &v
}

// GetContext returns the Context field value if set, zero value otherwise.
func (o *RevokeConsentRequest) GetContext() string {
	if o == nil || IsNil(o.Context) {
		var ret string
		return ret
	}
	return *o.Context
}

// GetContextOk returns a tuple with the Context field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RevokeConsentRequest) GetContextOk() (*string, bool) {
	if o == nil || IsNil(o.Context) {
		return nil, false
	}
	return o.Context, true
}

// HasContext returns a boolean if a field has been set.
func (o *RevokeConsentRequest) HasContext() bool {
	if o != nil && !IsNil(o.Context) {
		return true
	}

	return false
}

// SetContext gets a reference to the given string and assigns it to the Context field.
func (o *RevokeConsentRequest) SetContext(v string) {
	o.Context = &v
}

func (o RevokeConsentRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RevokeConsentRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	if !IsNil(o.ConsentId) {
		toSerialize["consent_id"] = o.ConsentId
	}
	if !IsNil(o.Context) {
		toSerialize["context"] = o.Context
	}
	return toSerialize, nil
}

type NullableRevokeConsentRequest struct {
	value *RevokeConsentRequest
	isSet bool
}

func (v NullableRevokeConsentRequest) Get() *RevokeConsentRequest {
	return v.value
}

func (v *NullableRevokeConsentRequest) Set(val *RevokeConsentRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableRevokeConsentRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableRevokeConsentRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRevokeConsentRequest(val *RevokeConsentRequest) *NullableRevokeConsentRequest {
	return &NullableRevokeConsentRequest{value: val, isSet: true}
}

func (v NullableRevokeConsentRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRevokeConsentRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


